/*
 * (C) Copyright Ian D. Romanick 2007
 * All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * on the rights to use, copy, modify, merge, publish, distribute, sub
 * license, and/or sell copies of the Software, and to permit persons to whom
 * the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.  IN NO EVENT SHALL
 * AUTHORS, COPYRIGHT HOLDERS, AND/OR THEIR SUPPLIERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include <GL/glext.h>

#define glDeleteObjectARB \
    (*gl_deleteobject_arb)
extern PFNGLDELETEOBJECTARBPROC gl_deleteobject_arb;

#define glGetHandleARB \
    (*gl_GetHandle_ARB)
extern PFNGLGETHANDLEARBPROC gl_GetHandle_ARB;

#define glDetachObjectARB \
    (*gl_DetachObject_ARB)
extern PFNGLDETACHOBJECTARBPROC gl_DetachObject_ARB;

#define glCreateShaderObjectARB \
    (*gl_CreateShaderObject_ARB)
extern PFNGLCREATESHADEROBJECTARBPROC gl_CreateShaderObject_ARB;

#define glShaderSourceARB \
    (*gl_ShaderSource_ARB)
extern PFNGLSHADERSOURCEARBPROC gl_ShaderSource_ARB;

#define glCompileShaderARB \
    (*gl_CompileShader_ARB)
extern PFNGLCOMPILESHADERARBPROC gl_CompileShader_ARB;

#define glCreateProgramObjectARB \
    (*gl_CreateProgramObject_ARB)
extern PFNGLCREATEPROGRAMOBJECTARBPROC gl_CreateProgramObject_ARB;

#define glAttachObjectARB \
    (*gl_AttachObject_ARB)
extern PFNGLATTACHOBJECTARBPROC gl_AttachObject_ARB;

#define glLinkProgramARB \
    (*gl_LinkProgram_ARB)
extern PFNGLLINKPROGRAMARBPROC gl_LinkProgram_ARB;

#define glUseProgramObjectARB \
    (*gl_UseProgramObject_ARB)
extern PFNGLUSEPROGRAMOBJECTARBPROC gl_UseProgramObject_ARB;

#define glValidateProgramARB \
    (*gl_ValidateProgram_ARB)
extern PFNGLVALIDATEPROGRAMARBPROC gl_ValidateProgram_ARB;

#define glUniform1fARB \
    (*gl_Uniform1f_ARB)
extern PFNGLUNIFORM1FARBPROC gl_Uniform1f_ARB;

#define glUniform2fARB \
    (*gl_Uniform2f_ARB)
extern PFNGLUNIFORM2FARBPROC gl_Uniform2f_ARB;

#define glUniform3fARB \
    (*gl_Uniform3f_ARB)
extern PFNGLUNIFORM3FARBPROC gl_Uniform3f_ARB;

#define glUniform4fARB \
    (*gl_Uniform4f_ARB)
extern PFNGLUNIFORM4FARBPROC gl_Uniform4f_ARB;

#define glUniform1iARB \
    (*gl_Uniform1i_ARB)
extern PFNGLUNIFORM1IARBPROC gl_Uniform1i_ARB;

#define glUniform2iARB \
    (*gl_Uniform2i_ARB)
extern PFNGLUNIFORM2IARBPROC gl_Uniform2i_ARB;

#define glUniform3iARB \
    (*gl_Uniform3i_ARB)
extern PFNGLUNIFORM3IARBPROC gl_Uniform3i_ARB;

#define glUniform4iARB \
    (*gl_Uniform4i_ARB)
extern PFNGLUNIFORM4IARBPROC gl_Uniform4i_ARB;

#define glUniform1fvARB \
    (*gl_Uniform1fv_ARB)
extern PFNGLUNIFORM1FVARBPROC gl_Uniform1fv_ARB;

#define glUniform2fvARB \
    (*gl_Uniform2fv_ARB)
extern PFNGLUNIFORM2FVARBPROC gl_Uniform2fv_ARB;

#define glUniform3fvARB \
    (*gl_Uniform3fv_ARB)
extern PFNGLUNIFORM3FVARBPROC gl_Uniform3fv_ARB;

#define glUniform4fvARB \
    (*gl_Uniform4fv_ARB)
extern PFNGLUNIFORM4FVARBPROC gl_Uniform4fv_ARB;

#define glUniform1ivARB \
    (*gl_Uniform1iv_ARB)
extern PFNGLUNIFORM1IVARBPROC gl_Uniform1iv_ARB;

#define glUniform2ivARB \
    (*gl_Uniform2iv_ARB)
extern PFNGLUNIFORM2IVARBPROC gl_Uniform2iv_ARB;

#define glUniform3ivARB \
    (*gl_Uniform3iv_ARB)
extern PFNGLUNIFORM3IVARBPROC gl_Uniform3iv_ARB;

#define glUniform4ivARB \
    (*gl_Uniform4iv_ARB)
extern PFNGLUNIFORM4IVARBPROC gl_Uniform4iv_ARB;

#define glUniformMatrix2fvARB \
    (*gl_UniformMatrix2fv_ARB)
extern PFNGLUNIFORMMATRIX2FVARBPROC gl_UniformMatrix2fv_ARB;

#define glUniformMatrix3fvARB \
    (*gl_UniformMatrix3fv_ARB)
extern PFNGLUNIFORMMATRIX3FVARBPROC gl_UniformMatrix3fv_ARB;

#define glUniformMatrix4fvARB \
    (*gl_UniformMatrix4fv_ARB)
extern PFNGLUNIFORMMATRIX4FVARBPROC gl_UniformMatrix4fv_ARB;

#define glGetObjectParameterfvARB \
    (*gl_GetObjectParameterfv_ARB)
extern PFNGLGETOBJECTPARAMETERFVARBPROC gl_GetObjectParameterfv_ARB;

#define glGetObjectParameterivARB \
    (*gl_GetObjectParameteriv_ARB)
extern PFNGLGETOBJECTPARAMETERIVARBPROC gl_GetObjectParameteriv_ARB;

#define glGetInfoLogARB \
    (*gl_GetInfoLog_ARB)
extern PFNGLGETINFOLOGARBPROC gl_GetInfoLog_ARB;

#define glGetAttachedObjectsARB \
    (*gl_GetAttachedObjects_ARB)
extern PFNGLGETATTACHEDOBJECTSARBPROC gl_GetAttachedObjects_ARB;

#define glGetUniformLocationARB \
    (*gl_GetUniformLocation_ARB)
extern PFNGLGETUNIFORMLOCATIONARBPROC gl_GetUniformLocation_ARB;

#define glGetActiveUniformARB \
    (*gl_GetActiveUniform_ARB)
extern PFNGLGETACTIVEUNIFORMARBPROC gl_GetActiveUniform_ARB;

#define glGetUniformfvARB \
    (*gl_GetUniformfv_ARB)
extern PFNGLGETUNIFORMFVARBPROC gl_GetUniformfv_ARB;

#define glGetUniformivARB \
    (*gl_GetUniformiv_ARB)
extern PFNGLGETUNIFORMIVARBPROC gl_GetUniformiv_ARB;

#define glGetShaderSourceARB \
    (*gl_GetShaderSource_ARB)
extern PFNGLGETSHADERSOURCEARBPROC gl_GetShaderSource_ARB;

#define glBindAttribLocationARB \
    (*gl_BindAttribLocation_ARB)
extern PFNGLBINDATTRIBLOCATIONARBPROC gl_BindAttribLocation_ARB;

#define glGetActiveAttribARB \
    (*gl_GetActiveAttrib_ARB)
extern PFNGLGETACTIVEATTRIBARBPROC gl_GetActiveAttrib_ARB;

#define glGetAttribLocationARB \
    (*gl_GetAttribLocation_ARB)
extern PFNGLGETATTRIBLOCATIONARBPROC gl_GetAttribLocation_ARB;

#define glVertexAttribPointerARB \
    (*gl_VertexAttribPointer_ARB)
extern PFNGLVERTEXATTRIBPOINTERARBPROC gl_VertexAttribPointer_ARB;

#define glEnableVertexAttribArrayARB \
    (*gl_EnableVertexAttribArray_ARB)
extern PFNGLENABLEVERTEXATTRIBARRAYARBPROC gl_EnableVertexAttribArray_ARB;

#define glDisableVertexAttribArrayARB \
    (*gl_DisableVertexAttribArray_ARB)
extern PFNGLDISABLEVERTEXATTRIBARRAYARBPROC gl_DisableVertexAttribArray_ARB;

bool init_glsl_glue(void);

GLcharARB *glsl_load_shader_code(const char *file_name);
