varying vec3 light_dir;
varying vec3 eye_dir;

uniform vec3 light_pos;

attribute vec3 tangent;

void main(void)
{
    vec3 eye_pos = vec3(gl_ModelViewMatrix * gl_Vertex);

    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
    

    vec3 t = normalize(gl_NormalMatrix * tangent);
    vec3 n = normalize(gl_NormalMatrix * gl_Normal);
    vec3 b = cross(n, t);

    vec3 v;

    v.x = dot(light_pos, t);
    v.y = dot(light_pos, b);
    v.z = dot(light_pos, n);
    light_dir = normalize(v);

    v.x = dot(eye_pos, t);
    v.y = dot(eye_pos, b);
    v.z = dot(eye_pos, n);
    eye_dir = normalize(v);
}
